// vX̖ (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool msave(char *_fname, unsigned char *_adr, int _size)
{
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(_adr, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i;
	unsigned char id1[] = "LAPLACE X1   Sys";
	unsigned char id2[] = "Disk 3 maker Sys";

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		// ȃf[^̕ŃfBXN𔻒
		if (!memcmp(&buff[1], id1, sizeof(id1)-1))
		{
			printf("Disk 1F܂.\n");
			disk.SetRecordRange(0x01,0x05);
			fcut("DRIVER", 0x03, 0x01, 0x01, 0x01, 0x03, 0x0000, 0x1c00);
			// CBGM1 ܂
			disk.ReadDATA(0x23, 0x11, 0x01, 0x02, 0x03, &buff[0x0000], 0x1200);
			disk.ReadDATA(0x0b, 0x05, 0x01, 0x02, 0x03, &buff[0x1200], 0x0200);
			msave("MUSIC1", buff, 0x1400);
			// CBGM2
			fcut("MUSIC2", 0x24, 0x12, 0x00, 0x01, 0x03, 0x0200, 0x1600);
			// 
			fcut("MUSIC3", 0x0a, 0x05, 0x00, 0x01, 0x03, 0x0000, 0x0080);
			// ze
			fcut("MUSIC4", 0x4e, 0x27, 0x00, 0x05, 0x03, 0x0200, 0x0100);
			// GfBO1 ܂(T_T)
			disk.ReadDATA(0x29, 0x14, 0x01, 0x04, 0x03, &buff[0x0000], 0x400);
			disk.ReadDATA(0x47, 0x23, 0x01, 0x04, 0x03, &buff[0x0400], 0x100);
			disk.ReadDATA(0x4f, 0x27, 0x01, 0x05, 0x03, &buff[0x1000], 0x400);
			memcpy(&buff[0x0500],&buff[0x1300],0x100);
			msave("MUSIC5", &buff[0x0300], 0x0300);
			// GfBO2 ܂(T_T)
			disk.ReadDATA(0x44, 0x22, 0x00, 0x04, 0x03, &buff[0x0000], 0x700);
			disk.ReadDATA(0x3a, 0x1d, 0x00, 0x03, 0x03, &buff[0x0700], 0x200);
			disk.ReadDATA(0x08, 0x04, 0x00, 0x04, 0x03, &buff[0x1000], 0x400);
			memcpy(&buff[0x0900],&buff[0x1100],0x200);
			msave("MUSIC6", buff, 0x0b00);
		}
		else if (!memcmp(&buff[1], id2, sizeof(id2)-1))
		{
			printf("Disk 2F܂.\n");
		}
	}
	return 0;
}

